var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = build;

var _esperanto = require('esperanto');

var _esperanto2 = _interopRequireWildcard(_esperanto);

var _fs = require('fs');

var _fs2 = _interopRequireWildcard(_fs);

var _path = require('path');

var _path2 = _interopRequireWildcard(_path);

var _lodash$includes$result$template = require('lodash');

var _lodash$includes$result$template2 = _interopRequireWildcard(_lodash$includes$result$template);

var _aliasToReal = require('lodash-cli/lib/mapping');

var _chainableMethods = require('./lodash-chainable');

var _chainableMethods2 = _interopRequireWildcard(_chainableMethods);

var buildPath = _path2['default'].join(__dirname, '../templates/import-build.tpl');
var chainPath = _path2['default'].join(__dirname, '../templates/chain-build.tpl');
var normalTemplate = _lodash$includes$result$template.template(_fs2['default'].readFileSync(buildPath));
var chainTemplate = _lodash$includes$result$template.template(_fs2['default'].readFileSync(chainPath));

function build(methods, modules, options) {
  var _path = _lodash$includes$result$template.result(options, 'lodashPath') || '';

  var _path$parse = _path2['default'].parse(_path);

  var ext = _path$parse.ext;
  var dir = _path$parse.dir;
  var name = _path$parse.name;
  var base = _path$parse.base;

  var chainBuild = _lodash$includes$result$template.includes(methods, 'chain');

  // Don't rel a cjs import
  if (options.output != null && (ext !== '' || dir !== '' || name !== base)) {
    _path = _path2['default'].relative(_path2['default'].dirname(options.output), _path);
  }

  if (options.useNpmModules && chainBuild) {
    throw new Error('Cannot currently use npm modules with a library using chaining');
  }

  // Otherwise compile a file for them to the modularization
  var config = _lodash$includes$result$template2['default'].chain(methods).map(function (name) {
    for (var category in modules) {
      if (_lodash$includes$result$template.includes(modules[category], name)) {
        break;
      }
    }
    var realName = _lodash$includes$result$template.result(_aliasToReal.aliasToReal, name, name);
    return {
      name: name,
      propString: '' + name + ': ' + name,
      path: options.useNpmModules ? 'lodash.' + realName.toLowerCase() : _path2['default'].join(_path, category, realName),
      chained: _chainableMethods2['default'][name]
    };
  }).partition(function (node) {
    return /\/chain\//.test(node.path);
  }).value();

  var template = chainBuild ? chainTemplate : normalTemplate;
  var code = template({
    config: config[1],
    chainMethods: config[0],
    lodashPath: _path
  });

  var opts = {
    _evilES3SafeReExports: true,
    strict: false,
    name: options.global || '_'
  };
  switch (options.exports) {
    case 'cjs':
      return _esperanto2['default'].toCjs(code, opts);
    case 'amd':
      return _esperanto2['default'].toAmd(code, opts);
    case 'umd':
      return _esperanto2['default'].toUmd(code, opts);
    case 'es6':
      return { code: code };
  }
  throw 'Unsupported format: ' + options.exports;
}

module.exports = exports['default'];