var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.resolve = resolve;
exports['default'] = modularize;

var _fs = require('./fs');

var _fs2 = _interopRequireWildcard(_fs);

var _lodashModules = require('./lodashModules');

var _lodashModules2 = _interopRequireWildcard(_lodashModules);

var _parseForModules = require('./parseForModules');

var _parseForModules2 = _interopRequireWildcard(_parseForModules);

var _defaults$flatten$isArray$uniq = require('lodash');

var _Promise = require('bluebird');

var _Promise2 = _interopRequireWildcard(_Promise);

var _esperantoBuild = require('./esperanto-build');

var _esperantoBuild2 = _interopRequireWildcard(_esperantoBuild);

var _cliBuild = require('./cli-build');

var _cliBuild2 = _interopRequireWildcard(_cliBuild);

var glob = _Promise2['default'].promisify(require('glob'));

var defaultOpts = require('../defaults.json');

function resolve(files, options) {
  return _Promise2['default'].map(files, function (file) {
    return _fs2['default'].readFileAsync(file).then(function (blob) {
      return _parseForModules2['default'](blob, file, options);
    });
  }).then(function (methods) {
    return _defaults$flatten$isArray$uniq.uniq(_defaults$flatten$isArray$uniq.flatten(methods).sort(), true);
  });
}

function modularize(fileGlob, options) {
  var files = (_defaults$flatten$isArray$uniq.isArray(fileGlob) ? _Promise2['default'].resolve(fileGlob) : glob(fileGlob)).then(function (files) {
    return resolve(files, options);
  });

  options = _defaults$flatten$isArray$uniq.defaults({}, options, defaultOpts);

  return _Promise2['default'].all([files, _lodashModules2['default']]).spread(function (methods, modules) {
    // What to do with the resulting methods (e.g. export, list, etc)
    if (options.list) {
      return methods;
    }
    var code = undefined;
    if (options.compile) {
      code = _cliBuild2['default'](methods, options);
    } else {
      code = _esperantoBuild2['default'](methods, modules, options).code;
    }
    var $code = _Promise2['default'].resolve(code).then(function ($code) {
      code = String($code);
      return code;
    });
    if (options.output) {
      $code = $code.then(function (code) {
        return _fs2['default'].writeFileAsync(options.output, code);
      });
    }
    return $code.then(function () {
      return {
        code: code,
        methods: methods
      };
    });
  });
}

module.exports = modularize;